/*
    Refer License for Terms & Conditions
 */

import 'package:flutter/material.dart';
import 'package:bui_component/Constants/AppColors.dart';

// ignore: must_be_immutable
class HomeScreenComponent extends StatefulWidget {
  final Function() onMenuPressed;
  final Function() onNotificationFunction;
  final Function() onSettingFunction;
  final Function() onMessageFunction;
  final Function(int s) onPopUpMenuFunction;
  final Color backgroundColor;
  final List<PopupMenuItem> popUpMenu;

  final Widget child;

  HomeScreenComponent({
    Key key,
    @required this.onMenuPressed,
    @required this.onNotificationFunction,
    @required this.onPopUpMenuFunction,
    @required this.onSettingFunction,
    @required this.onMessageFunction,
    @required this.backgroundColor,
    @required this.child,
    @required this.popUpMenu,
  });

  @override
  _HomeScreenComponentState createState() => _HomeScreenComponentState();
}

class _HomeScreenComponentState extends State<HomeScreenComponent> {


  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: AppColors.APP_COLOR_WHITE,
      body: SafeArea(
          child: Stack(
        children: [
          Container(
            height: 60,
            color: widget.backgroundColor != null
                ? widget.backgroundColor
                : AppColors.APP_COLOR_PRIMARY,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                ClipRRect(
                  borderRadius: BorderRadius.all(Radius.circular(32.0)),
                  child: InkWell(
                    splashColor: AppColors.errorWarning,
                    focusColor: AppColors.APP_COLOR_WHITE,
                    onTap: () {
                      widget.onMenuPressed();
                    },
                    child: Padding(
                      padding: const EdgeInsets.all(12.0),
                      child: Icon(
                        Icons.menu,
                        color: Colors.white,
                      ),
                    ),
                  ),
                ),
                SizedBox(
                  width: 130,
                ),
                /* ClipRRect(
                      borderRadius: BorderRadius.all(Radius.circular(32.0)),
                      child: InkWell(
                        splashColor: AppColors.errorWarning,
                        focusColor: AppColors.APP_COLOR_WHITE,
                        onTap: () {
                          widget.onNotificationFunction();
                        },
                        child: Padding(
                          padding: const EdgeInsets.all(12.0),
                          child: Icon(
                            Icons.notifications_active,
                            color: Colors.white,
                          ),
                        ),
                      ),
                    ),
                    SizedBox(
                      width: 10,
                    ),
                    ClipRRect(
                      borderRadius: BorderRadius.all(Radius.circular(32.0)),
                      child: InkWell(
                        splashColor: AppColors.errorWarning,
                        focusColor: AppColors.APP_COLOR_WHITE,
                        onTap: () {
                          widget.onSettingFunction();
                        },
                        child: Padding(
                          padding: const EdgeInsets.all(12.0),
                          child: Icon(
                            Icons.settings,
                            color: Colors.white,
                          ),
                        ),
                      ),
                    ),
                    SizedBox(
                      width: 10,
                    ),
                    ClipRRect(
                      borderRadius: BorderRadius.all(Radius.circular(32.0)),
                      child: InkWell(
                        splashColor: AppColors.errorWarning,
                        focusColor: AppColors.APP_COLOR_WHITE,
                        onTap: () {
                          widget.onMessageFunction();
                        },
                        child: Padding(
                          padding: const EdgeInsets.all(12.0),
                          child: Icon(
                            Icons.messenger_rounded,
                            color: Colors.white,
                          ),
                        ),
                      ),
                    ),*/

                Container(
                    padding: EdgeInsets.only(right: 15),
                    child: PopupMenuButton(
                      elevation: 30,
                      //offset: Offset(0, 100),
                      tooltip: "More Feature",
                      itemBuilder: (context) => widget.popUpMenu,
                      onCanceled: () {},
                      onSelected: (value) {
                        widget.onPopUpMenuFunction(value);
                      },
                      icon: Icon(
                        Icons.more_vert_sharp,
                        color: AppColors.appWhite,
                      ),
                    )),
              ],
            ),
          ),
          widget.child != null ? widget.child : Container(),
        ],
      )),
    );
  }
}
